function [FSq_l, FSq_u] = setestimator_q(phi)

gridleng = 0.0001;
grid_q = [-1:gridleng:1];
n_grid = size(grid_q,2);

idq = [];

for i = 1:n_grid,
    q1 = grid_q(1,i);
    q21 = sqrt(1-q1^2);
    q22 = -q21;
 if size(phi,1) ==3
    theta1 = [q1 0 0]*phi;
    mu1 = [ 0 q1 q21]*phi;
    
    theta2 = [q1 0 0]*phi;
    mu2 = [ 0 q1 q22]*phi;
 elseif size(phi,1)==4
    theta1 = [q1 q21 0 0]*phi;
    mu1 = [ 0 0 q1 q21]*phi;
    
    theta2 = [q1 q22 0 0]*phi;
    mu2 = [ 0 0 q1 q22]*phi;

 end

    if (theta1 >= 0) && (mu1 >=0)
        idq = [idq;q1];
    end
    
    if (theta2 >= 0) && (mu2 >=0)
        idq = [idq;q1];
    end

end

idq = sort(idq);
FSq_l = idq(1,1);
FSq_u = idq(end,1);
