function [FSq_l, FSq_u, q_star] = setestimator_q(phi, stepsize)

if size(phi,1) ==3
    angle = [-pi/2 : stepsize : pi/2];
elseif size(phi,1)==4
    angle = [-pi : stepsize : pi];
end

idq = [];

for i = 1:size(angle,2)
   q1 = cos(angle(1,i));
   q2 = sin(angle(1,i));

 if size(phi,1) ==3
    theta = [q1 0 0]*phi;
    mu = [ 0 q1 q2]*phi;
    
 elseif size(phi,1)==4
    theta = [q1 q2 0 0]*phi;
    mu = [ 0 0 q1 q2]*phi;
    
 end

    if (theta >= 0) && (mu >=0)
        idq = [idq;q1];
    end
    
end

idq = sort(idq);
FSq_l = idq(1,1);
FSq_u = idq(end,1);
